class AddForeignKeyConstraints < ActiveRecord::Migration
  def self.up
	execute %{

-- Commented-out constraints are ones being put off for future migrations pending database cleanup.

ALTER TABLE "citations" ADD CONSTRAINT "fk_citations_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "citations_sites" ADD CONSTRAINT "fk_citations_sites_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id") ON DELETE CASCADE;
ALTER TABLE "citations_sites" ADD CONSTRAINT "fk_citations_sites_sites_1" FOREIGN KEY ("site_id") REFERENCES "sites" ("id") ON DELETE RESTRICT;
ALTER TABLE "citations_treatments" ADD CONSTRAINT "fk_citations_treatments_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id") ON DELETE CASCADE;
ALTER TABLE "citations_treatments" ADD CONSTRAINT "fk_citations_treatments_treatments_1" FOREIGN KEY ("treatment_id") REFERENCES "treatments" ("id") ON DELETE CASCADE;
-- ALTER TABLE "covariates" ADD CONSTRAINT "fk_covariates_traits_1" FOREIGN KEY ("trait_id") REFERENCES "traits" ("id");
ALTER TABLE "covariates" ADD CONSTRAINT "fk_covariates_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id");
ALTER TABLE "cultivars" ADD CONSTRAINT "fk_cultivars_species_1" FOREIGN KEY ("specie_id") REFERENCES "species" ("id");
ALTER TABLE "current_posteriors" ADD CONSTRAINT "fk_current_posteriors_pfts_1" FOREIGN KEY ("pft_id") REFERENCES "pfts" ("id");
ALTER TABLE "current_posteriors" ADD CONSTRAINT "fk_current_posteriors_posterior_samples_1" FOREIGN KEY ("posteriors_samples_id") REFERENCES "posterior_samples" ("id");
ALTER TABLE "current_posteriors" ADD CONSTRAINT "fk_current_posteriors_projects_1" FOREIGN KEY ("project_id") REFERENCES "projects" ("id");
ALTER TABLE "current_posteriors" ADD CONSTRAINT "fk_current_posteriors_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id");
ALTER TABLE "dbfiles" ADD CONSTRAINT "fk_dbfiles_machines_1" FOREIGN KEY ("machine_id") REFERENCES "machines" ("id");
ALTER TABLE "dbfiles" ADD CONSTRAINT "fk_dbfiles_users_1" FOREIGN KEY ("created_user_id") REFERENCES "users" ("id");
ALTER TABLE "dbfiles" ADD CONSTRAINT "fk_dbfiles_users_2" FOREIGN KEY ("updated_user_id") REFERENCES "users" ("id");
ALTER TABLE "ensembles" ADD CONSTRAINT "fk_ensembles_workflows_1" FOREIGN KEY ("workflow_id") REFERENCES "workflows" ("id");
ALTER TABLE "entities" ADD CONSTRAINT "fk_entities_entities_1" FOREIGN KEY ("parent_id") REFERENCES "entities" ("id");
ALTER TABLE "formats_variables" ADD CONSTRAINT "fk_formats_variables_formats_1" FOREIGN KEY ("format_id") REFERENCES "formats" ("id") ON DELETE CASCADE;
ALTER TABLE "formats_variables" ADD CONSTRAINT "fk_formats_variables_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id") ON DELETE CASCADE;
ALTER TABLE "inputs" ADD CONSTRAINT "fk_inputs_formats_1" FOREIGN KEY ("format_id") REFERENCES "formats" ("id");
ALTER TABLE "inputs" ADD CONSTRAINT "fk_inputs_inputs_1" FOREIGN KEY ("parent_id") REFERENCES "inputs" ("id");
ALTER TABLE "inputs" ADD CONSTRAINT "fk_inputs_sites_1" FOREIGN KEY ("site_id") REFERENCES "sites" ("id");
ALTER TABLE "inputs" ADD CONSTRAINT "fk_inputs_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "inputs_runs" ADD CONSTRAINT "fk_inputs_runs_inputs_1" FOREIGN KEY ("input_id") REFERENCES "inputs" ("id") ON DELETE CASCADE;
ALTER TABLE "inputs_runs" ADD CONSTRAINT "fk_inputs_runs_runs_1" FOREIGN KEY ("run_id") REFERENCES "runs" ("id") ON DELETE CASCADE;
ALTER TABLE "inputs_variables" ADD CONSTRAINT "fk_inputs_variables_inputs_1" FOREIGN KEY ("input_id") REFERENCES "inputs" ("id") ON DELETE CASCADE;
ALTER TABLE "inputs_variables" ADD CONSTRAINT "fk_inputs_variables_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id") ON DELETE CASCADE;
ALTER TABLE "likelihoods" ADD CONSTRAINT "fk_likelihoods_inputs_1" FOREIGN KEY ("input_id") REFERENCES "inputs" ("id");
ALTER TABLE "likelihoods" ADD CONSTRAINT "fk_likelihoods_runs_1" FOREIGN KEY ("run_id") REFERENCES "runs" ("id");
ALTER TABLE "likelihoods" ADD CONSTRAINT "fk_likelihoods_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id");
ALTER TABLE "location_yields" ADD CONSTRAINT "fk_location_yields_counties_1" FOREIGN KEY ("county_id") REFERENCES "counties" ("id");
ALTER TABLE "managements" ADD CONSTRAINT "fk_managements_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id");
ALTER TABLE "managements" ADD CONSTRAINT "fk_managements_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "managements_treatments" ADD CONSTRAINT "fk_managements_treatments_managements_1" FOREIGN KEY ("management_id") REFERENCES "managements" ("id") ON DELETE CASCADE;
ALTER TABLE "managements_treatments" ADD CONSTRAINT "fk_managements_treatments_treatments_1" FOREIGN KEY ("treatment_id") REFERENCES "treatments" ("id") ON DELETE CASCADE;
ALTER TABLE "methods" ADD CONSTRAINT "fk_methods_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id");
ALTER TABLE "models" ADD CONSTRAINT "fk_models_modeltypes_1" FOREIGN KEY ("modeltype_id") REFERENCES "modeltypes" ("id");
ALTER TABLE "models" ADD CONSTRAINT "fk_models_models_1" FOREIGN KEY ("parent_id") REFERENCES "models" ("id");
ALTER TABLE "modeltypes" ADD CONSTRAINT "fk_modeltypes_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "modeltypes_formats" ADD CONSTRAINT "fk_modeltypes_formats_formats_1" FOREIGN KEY ("format_id") REFERENCES "formats" ("id") ON DELETE CASCADE;
ALTER TABLE "modeltypes_formats" ADD CONSTRAINT "fk_modeltypes_formats_modeltypes_1" FOREIGN KEY ("modeltype_id") REFERENCES "modeltypes" ("id") ON DELETE CASCADE;
ALTER TABLE "modeltypes_formats" ADD CONSTRAINT "fk_modeltypes_formats_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "pfts" ADD CONSTRAINT "fk_pfts_modeltypes_1" FOREIGN KEY ("modeltype_id") REFERENCES "modeltypes" ("id");
ALTER TABLE "pfts" ADD CONSTRAINT "fk_pfts_pfts_1" FOREIGN KEY ("parent_id") REFERENCES "pfts" ("id");
-- ALTER TABLE "pfts_priors" ADD CONSTRAINT "fk_pfts_priors_pfts_1" FOREIGN KEY ("pft_id") REFERENCES "pfts" ("id") ON DELETE CASCADE;
-- ALTER TABLE "pfts_priors" ADD CONSTRAINT "fk_pfts_priors_priors_1" FOREIGN KEY ("prior_id") REFERENCES "priors" ("id") ON DELETE CASCADE;
ALTER TABLE "posteriors" ADD CONSTRAINT "fk_posteriors_formats_1" FOREIGN KEY ("format_id") REFERENCES "formats" ("id");
ALTER TABLE "posteriors" ADD CONSTRAINT "fk_posteriors_pfts_1" FOREIGN KEY ("pft_id") REFERENCES "pfts" ("id");
ALTER TABLE "posterior_samples" ADD CONSTRAINT "fk_posterior_samples_posterior_samples_1" FOREIGN KEY ("parent_id") REFERENCES "posterior_samples" ("id");
ALTER TABLE "posterior_samples" ADD CONSTRAINT "fk_posterior_samples_pfts_1" FOREIGN KEY ("pft_id") REFERENCES "pfts" ("id");
ALTER TABLE "posterior_samples" ADD CONSTRAINT "fk_posterior_samples_posteriors_1" FOREIGN KEY ("posterior_id") REFERENCES "posteriors" ("id");
ALTER TABLE "posterior_samples" ADD CONSTRAINT "fk_posterior_samples_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id");
ALTER TABLE "posteriors_ensembles" ADD CONSTRAINT "fk_posteriors_ensembles_ensembles_1" FOREIGN KEY ("ensemble_id") REFERENCES "ensembles" ("id") ON DELETE CASCADE;
ALTER TABLE "posteriors_ensembles" ADD CONSTRAINT "fk_posteriors_ensembles_posteriors_1" FOREIGN KEY ("posterior_id") REFERENCES "posteriors" ("id") ON DELETE CASCADE;
ALTER TABLE "priors" ADD CONSTRAINT "fk_priors_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id");
ALTER TABLE "priors" ADD CONSTRAINT "fk_priors_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id");
ALTER TABLE "projects" ADD CONSTRAINT "fk_projects_machines_1" FOREIGN KEY ("machine_id") REFERENCES "machines" ("id");
ALTER TABLE "runs" ADD CONSTRAINT "fk_runs_ensembles_1" FOREIGN KEY ("ensemble_id") REFERENCES "ensembles" ("id");
ALTER TABLE "runs" ADD CONSTRAINT "fk_runs_models_1" FOREIGN KEY ("model_id") REFERENCES "models" ("id");
ALTER TABLE "runs" ADD CONSTRAINT "fk_runs_sites_1" FOREIGN KEY ("site_id") REFERENCES "sites" ("id");
ALTER TABLE "sites" ADD CONSTRAINT "fk_sites_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "trait_covariate_associations" ADD CONSTRAINT "fk_trait_covariate_associations_variables_1" FOREIGN KEY ("covariate_variable_id") REFERENCES "variables" ("id");
ALTER TABLE "trait_covariate_associations" ADD CONSTRAINT "fk_trait_covariate_associations_variables_2" FOREIGN KEY ("trait_variable_id") REFERENCES "variables" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_cultivars_1" FOREIGN KEY ("cultivar_id") REFERENCES "cultivars" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_entities_1" FOREIGN KEY ("entity_id") REFERENCES "entities" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_methods_1" FOREIGN KEY ("method_id") REFERENCES "methods" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_sites_1" FOREIGN KEY ("site_id") REFERENCES "sites" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_species_1" FOREIGN KEY ("specie_id") REFERENCES "species" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_treatments_1" FOREIGN KEY ("treatment_id") REFERENCES "treatments" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
-- ALTER TABLE "traits" ADD CONSTRAINT "fk_traits_variables_1" FOREIGN KEY ("variable_id") REFERENCES "variables" ("id");
-- ALTER TABLE "treatments" ADD CONSTRAINT "fk_treatments_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
ALTER TABLE "workflows" ADD CONSTRAINT "fk_workflows_models_1" FOREIGN KEY ("model_id") REFERENCES "models" ("id");
ALTER TABLE "workflows" ADD CONSTRAINT "fk_workflows_sites_1" FOREIGN KEY ("site_id") REFERENCES "sites" ("id");
ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_citations_1" FOREIGN KEY ("citation_id") REFERENCES "citations" ("id");
ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_cultivars_1" FOREIGN KEY ("cultivar_id") REFERENCES "cultivars" ("id");
ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_methods_1" FOREIGN KEY ("method_id") REFERENCES "methods" ("id");
-- ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_sites_1" FOREIGN KEY ("site_id") REFERENCES "sites" ("id");
ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_species_1" FOREIGN KEY ("specie_id") REFERENCES "species" ("id");
ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_treatments_1" FOREIGN KEY ("treatment_id") REFERENCES "treatments" ("id");
ALTER TABLE "yields" ADD CONSTRAINT "fk_yields_users_1" FOREIGN KEY ("user_id") REFERENCES "users" ("id");
}
  end

  def self.down
	execute %{
ALTER TABLE "citations" DROP CONSTRAINT "fk_citations_users_1";
ALTER TABLE "citations_sites" DROP CONSTRAINT "fk_citations_sites_citations_1";
ALTER TABLE "citations_sites" DROP CONSTRAINT "fk_citations_sites_sites_1";
ALTER TABLE "citations_treatments" DROP CONSTRAINT "fk_citations_treatments_citations_1";
ALTER TABLE "citations_treatments" DROP CONSTRAINT "fk_citations_treatments_treatments_1";
-- ALTER TABLE "covariates" DROP CONSTRAINT "fk_covariates_traits_1";
ALTER TABLE "covariates" DROP CONSTRAINT "fk_covariates_variables_1";
ALTER TABLE "cultivars" DROP CONSTRAINT "fk_cultivars_species_1";
ALTER TABLE "current_posteriors" DROP CONSTRAINT "fk_current_posteriors_pfts_1";
ALTER TABLE "current_posteriors" DROP CONSTRAINT "fk_current_posteriors_posterior_samples_1";
ALTER TABLE "current_posteriors" DROP CONSTRAINT "fk_current_posteriors_projects_1";
ALTER TABLE "current_posteriors" DROP CONSTRAINT "fk_current_posteriors_variables_1";
ALTER TABLE "dbfiles" DROP CONSTRAINT "fk_dbfiles_machines_1";
ALTER TABLE "dbfiles" DROP CONSTRAINT "fk_dbfiles_users_1";
ALTER TABLE "dbfiles" DROP CONSTRAINT "fk_dbfiles_users_2";
ALTER TABLE "ensembles" DROP CONSTRAINT "fk_ensembles_workflows_1";
ALTER TABLE "entities" DROP CONSTRAINT "fk_entities_entities_1";
ALTER TABLE "formats_variables" DROP CONSTRAINT "fk_formats_variables_formats_1";
ALTER TABLE "formats_variables" DROP CONSTRAINT "fk_formats_variables_variables_1";
ALTER TABLE "inputs" DROP CONSTRAINT "fk_inputs_formats_1";
ALTER TABLE "inputs" DROP CONSTRAINT "fk_inputs_inputs_1";
ALTER TABLE "inputs" DROP CONSTRAINT "fk_inputs_sites_1";
ALTER TABLE "inputs" DROP CONSTRAINT "fk_inputs_users_1";
ALTER TABLE "inputs_runs" DROP CONSTRAINT "fk_inputs_runs_inputs_1";
ALTER TABLE "inputs_runs" DROP CONSTRAINT "fk_inputs_runs_runs_1";
ALTER TABLE "inputs_variables" DROP CONSTRAINT "fk_inputs_variables_inputs_1";
ALTER TABLE "inputs_variables" DROP CONSTRAINT "fk_inputs_variables_variables_1";
ALTER TABLE "likelihoods" DROP CONSTRAINT "fk_likelihoods_inputs_1";
ALTER TABLE "likelihoods" DROP CONSTRAINT "fk_likelihoods_runs_1";
ALTER TABLE "likelihoods" DROP CONSTRAINT "fk_likelihoods_variables_1";
ALTER TABLE "location_yields" DROP CONSTRAINT "fk_location_yields_counties_1";
ALTER TABLE "managements" DROP CONSTRAINT "fk_managements_citations_1";
ALTER TABLE "managements" DROP CONSTRAINT "fk_managements_users_1";
ALTER TABLE "managements_treatments" DROP CONSTRAINT "fk_managements_treatments_managements_1";
ALTER TABLE "managements_treatments" DROP CONSTRAINT "fk_managements_treatments_treatments_1";
ALTER TABLE "methods" DROP CONSTRAINT "fk_methods_citations_1";
ALTER TABLE "models" DROP CONSTRAINT "fk_models_modeltypes_1";
ALTER TABLE "models" DROP CONSTRAINT "fk_models_models_1";
ALTER TABLE "modeltypes" DROP CONSTRAINT "fk_modeltypes_users_1";
ALTER TABLE "modeltypes_formats" DROP CONSTRAINT "fk_modeltypes_formats_formats_1";
ALTER TABLE "modeltypes_formats" DROP CONSTRAINT "fk_modeltypes_formats_modeltypes_1";
ALTER TABLE "modeltypes_formats" DROP CONSTRAINT "fk_modeltypes_formats_users_1";
ALTER TABLE "pfts" DROP CONSTRAINT "fk_pfts_modeltypes_1";
ALTER TABLE "pfts" DROP CONSTRAINT "fk_pfts_pfts_1";
-- ALTER TABLE "pfts_priors" DROP CONSTRAINT "fk_pfts_priors_pfts_1";
-- ALTER TABLE "pfts_priors" DROP CONSTRAINT "fk_pfts_priors_priors_1";
ALTER TABLE "posteriors" DROP CONSTRAINT "fk_posteriors_formats_1";
ALTER TABLE "posteriors" DROP CONSTRAINT "fk_posteriors_pfts_1";
ALTER TABLE "posterior_samples" DROP CONSTRAINT "fk_posterior_samples_posterior_samples_1";
ALTER TABLE "posterior_samples" DROP CONSTRAINT "fk_posterior_samples_pfts_1";
ALTER TABLE "posterior_samples" DROP CONSTRAINT "fk_posterior_samples_posteriors_1";
ALTER TABLE "posterior_samples" DROP CONSTRAINT "fk_posterior_samples_variables_1";
ALTER TABLE "posteriors_ensembles" DROP CONSTRAINT "fk_posteriors_ensembles_ensembles_1";
ALTER TABLE "posteriors_ensembles" DROP CONSTRAINT "fk_posteriors_ensembles_posteriors_1";
ALTER TABLE "priors" DROP CONSTRAINT "fk_priors_citations_1";
ALTER TABLE "priors" DROP CONSTRAINT "fk_priors_variables_1";
ALTER TABLE "projects" DROP CONSTRAINT "fk_projects_machines_1";
ALTER TABLE "runs" DROP CONSTRAINT "fk_runs_ensembles_1";
ALTER TABLE "runs" DROP CONSTRAINT "fk_runs_models_1";
ALTER TABLE "runs" DROP CONSTRAINT "fk_runs_sites_1";
ALTER TABLE "sites" DROP CONSTRAINT "fk_sites_users_1";
ALTER TABLE "trait_covariate_associations" DROP CONSTRAINT "fk_trait_covariate_associations_variables_1";
ALTER TABLE "trait_covariate_associations" DROP CONSTRAINT "fk_trait_covariate_associations_variables_2";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_citations_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_cultivars_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_entities_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_methods_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_sites_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_species_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_treatments_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_users_1";
-- ALTER TABLE "traits" DROP CONSTRAINT "fk_traits_variables_1";
-- ALTER TABLE "treatments" DROP CONSTRAINT "fk_treatments_users_1";
ALTER TABLE "workflows" DROP CONSTRAINT "fk_workflows_models_1";
ALTER TABLE "workflows" DROP CONSTRAINT "fk_workflows_sites_1";
ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_citations_1";
ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_cultivars_1";
ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_methods_1";
-- ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_sites_1";
ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_species_1";
ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_treatments_1";
ALTER TABLE "yields" DROP CONSTRAINT "fk_yields_users_1";
}
  end
end
