
# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe TreatmentsController do

  # This should return the minimal set of attributes required to create a valid
  # Treatment. As you add validations to Treatment, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { { name: "bogus" } }

  let(:invalid_attribute_set) { { name: nil } }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # TreatmentsController. Be sure to keep this updated too.
  let(:valid_session) {
    {
      user_id: 512127716,
      citation: 1
    }
  }

  describe "GET index" do
    it "assigns all treatments associated with the session citation as @treatments" do
      treatments = Citation.find(valid_session[:citation]).treatments
      get :index, params: {}, session: valid_session
      expect(assigns(:treatments)).to eq(treatments)
    end
  end

  describe "GET show" do
    it "assigns the requested treatment as @treatment" do
      treatment = Treatment.create! valid_attributes
      get :show, params: {:id => treatment.to_param}, session: valid_session
      expect(assigns(:treatment)).to eq(treatment)
    end
  end

  describe "GET new" do
    it "assigns a new treatment as @treatment" do
      get :new, params: {}, session: valid_session
      expect(assigns(:treatment)).to be_a_new(Treatment)
    end
  end

  describe "GET edit" do
    it "assigns the requested treatment as @treatment" do
      treatment = Treatment.create! valid_attributes
      get :edit, params: {:id => treatment.to_param}, session: valid_session
      expect(assigns(:treatment)).to eq(treatment)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Treatment" do
        expect {
          post :create, params: {:treatment => valid_attributes}, session: valid_session
        }.to change(Treatment, :count).by(1)
      end

      it "assigns a newly created treatment as @treatment" do
        post :create, params: {:treatment => valid_attributes}, session: valid_session
        expect(assigns(:treatment)).to be_a(Treatment)
        expect(assigns(:treatment)).to be_persisted
      end

      it "redirects to the treatment index page" do
        post :create, params: {:treatment => valid_attributes}, session: valid_session
        expect(response).to redirect_to(action: :index)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved treatment as @treatment" do
        # Trigger the behavior that occurs when invalid params are submitted
        allow_any_instance_of(Treatment).to receive(:save).and_return(false)
        post :create, params: {}, session: valid_session
        expect(assigns(:treatment)).to be_a_new(Treatment)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        allow_any_instance_of(Treatment).to receive(:save).and_return(false)
        post :create, params: {}, session: valid_session
        expect(response).to render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested treatment" do
        treatment = Treatment.create! valid_attributes
        # Assuming there are no other treatments in the database, this
        # specifies that the Treatment created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        expect_any_instance_of(Treatment).to receive(:update_attributes).with(ActionController::Parameters.new({ "these" => "params" }))
        put :update, params: {:id => treatment.to_param, :treatment => { "these" => "params" }}, session: valid_session
      end

      it "assigns the requested treatment as @treatment" do
        treatment = Treatment.create! valid_attributes
        put :update, params: {:id => treatment.to_param, :treatment => valid_attributes}, session: valid_session
        expect(assigns(:treatment)).to eq(treatment)
      end

      it "redirects to the treatment index page" do
        treatment = Treatment.create! valid_attributes
        put :update, params: {:id => treatment.to_param, :treatment => valid_attributes}, session: valid_session
        expect(response).to redirect_to(treatments_path)
      end
    end

    describe "with invalid params" do
      it "assigns the treatment as @treatment" do
        treatment = Treatment.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        allow_any_instance_of(Treatment).to receive(:save).and_return(false)
        put :update, params: {:id => treatment.to_param, :treatment => invalid_attribute_set}, session: valid_session
        expect(assigns(:treatment)).to eq(treatment)
      end

      it "re-renders the 'edit' template" do
        treatment = Treatment.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        allow_any_instance_of(Treatment).to receive(:save).and_return(false)
        put :update, params: {:id => treatment.to_param, :treatment => invalid_attribute_set}, session: valid_session
        expect(response).to render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested treatment" do
      treatment = Treatment.create! valid_attributes
      expect {
        delete :destroy, params: {:id => treatment.to_param}, session: valid_session
      }.to change(Treatment, :count).by(-1)
    end

    it "redirects to the treatments list" do
      treatment = Treatment.create! valid_attributes
      delete :destroy, params: {:id => treatment.to_param}, session: valid_session
      expect(response).to redirect_to(treatments_path)
    end
  end

end
